diff -pruN 2.1.0~rc4-1/.devcontainer/Dockerfile-centos9 2.1.0~rc5-1/.devcontainer/Dockerfile-centos9
--- 2.1.0~rc4-1/.devcontainer/Dockerfile-centos9	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/.devcontainer/Dockerfile-centos9	1970-01-01 00:00:00.000000000 +0000
@@ -1,7 +0,0 @@
-FROM quay.io/centos/centos:stream9
-
-COPY library-scripts/*.sh /tmp/library-scripts/
-RUN \
-  bash /tmp/library-scripts/add-repos-redhat.sh && \
-  bash /tmp/library-scripts/common-redhat.sh false automatic automatic automatic true false && \
-  bash /tmp/library-scripts/add-deps-redhat.sh
diff -pruN 2.1.0~rc4-1/.devcontainer/Dockerfile-el9 2.1.0~rc5-1/.devcontainer/Dockerfile-el9
--- 2.1.0~rc4-1/.devcontainer/Dockerfile-el9	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0~rc5-1/.devcontainer/Dockerfile-el9	2024-06-17 08:16:21.000000000 +0000
@@ -0,0 +1,7 @@
+FROM almalinux:9
+
+COPY library-scripts/*.sh /tmp/library-scripts/
+RUN \
+  bash /tmp/library-scripts/add-repos-redhat.sh && \
+  bash /tmp/library-scripts/common-redhat.sh false automatic automatic automatic true false && \
+  bash /tmp/library-scripts/add-deps-redhat.sh
diff -pruN 2.1.0~rc4-1/.devcontainer/devcontainer.json 2.1.0~rc5-1/.devcontainer/devcontainer.json
--- 2.1.0~rc4-1/.devcontainer/devcontainer.json	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/.devcontainer/devcontainer.json	2024-06-17 08:16:21.000000000 +0000
@@ -13,19 +13,23 @@
 
 	// The 'service' property is the name of the service for the container that VS Code should
 	// use. Update this value and .devcontainer/docker-compose.yml to the real service name.
-	"service": "container-centos7",
+	"service": "container-el9",
 
 	// Uncomment the next line if you want start specific services in your Docker Compose config.
-	"runServices": ["container-centos7"],
+	"runServices": ["container-el9"],
 
 	// The optional 'workspaceFolder' property is the path VS Code should open by default when
 	// connected. This is typically a file mount in .devcontainer/docker-compose.yml
 	"workspaceFolder": "/workspace",
 
-  "extensions": [
-    "ms-vscode.cpptools", "eamodio.gitlens"
-  ],
-
+	"customizations": {
+		"vscode": {
+			"extensions": [
+				"ms-vscode.cpptools",
+				"eamodio.gitlens"
+			]
+		}
+	},
 	// Use 'forwardPorts' to make a list of ports inside the container available locally.
 	// "forwardPorts": [],
 
diff -pruN 2.1.0~rc4-1/.devcontainer/docker-compose.yml 2.1.0~rc5-1/.devcontainer/docker-compose.yml
--- 2.1.0~rc4-1/.devcontainer/docker-compose.yml	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/.devcontainer/docker-compose.yml	2024-06-17 08:16:21.000000000 +0000
@@ -1,15 +1,21 @@
 
 services:
 
-  container-centos9:
+  container-el9:
+
+    environment:
+      - TZ=Europe/Rome
+
+    depends_on:
+      - trust
 
     build:
       context: .devcontainer
-      dockerfile: Dockerfile-centos9
+      dockerfile: Dockerfile-el9
 
     volumes:
       - trustanchors:/etc/grid-security/certificates
-      - .:/workspace:cached
+      - .:/workspace
 
     cap_add:
       - SYS_PTRACE
@@ -22,13 +28,19 @@ services:
 
   container-centos7:
 
+    environment:
+      - TZ=Europe/Rome
+
+    depends_on:
+      - trust
+
     build:
       context: .devcontainer
       dockerfile: Dockerfile-centos7
 
     volumes:
       - trustanchors:/etc/grid-security/certificates
-      - .:/workspace:cached
+      - .:/workspace
 
     cap_add:
       - SYS_PTRACE
diff -pruN 2.1.0~rc4-1/.github/workflows/ci.yml 2.1.0~rc5-1/.github/workflows/ci.yml
--- 2.1.0~rc4-1/.github/workflows/ci.yml	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/.github/workflows/ci.yml	2024-06-17 08:16:21.000000000 +0000
@@ -23,11 +23,11 @@ jobs:
           ./configure
           make
 
-  centos9:
+  el9:
     runs-on: ubuntu-latest
-    container: quay.io/centos/centos:stream9
+    container: almalinux:9
     steps:
-      - uses: actions/checkout@v3
+      - uses: actions/checkout@v4
 
       - name: Install packages
         run: |
@@ -43,7 +43,7 @@ jobs:
   ubuntu2004:
     runs-on: ubuntu-20.04
     steps:
-      - uses: actions/checkout@v3
+      - uses: actions/checkout@v4
 
       - name: Install packages
         run: |
diff -pruN 2.1.0~rc4-1/debian/changelog 2.1.0~rc5-1/debian/changelog
--- 2.1.0~rc4-1/debian/changelog	2024-05-03 16:29:09.000000000 +0000
+++ 2.1.0~rc5-1/debian/changelog	2024-06-18 15:42:12.000000000 +0000
@@ -1,3 +1,10 @@
+voms (2.1.0~rc5-1) unstable; urgency=medium
+
+  * Update to upstream version 2.1.0-rc5
+  * Move systemd unit file to /usr/lib/systemd/system (Closes: #1073714)
+
+ -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 18 Jun 2024 17:42:12 +0200
+
 voms (2.1.0~rc4-1) unstable; urgency=medium
 
   * Update to upstream version 2.1.0-rc4
diff -pruN 2.1.0~rc4-1/debian/copyright 2.1.0~rc5-1/debian/copyright
--- 2.1.0~rc4-1/debian/copyright	2024-05-03 16:27:18.000000000 +0000
+++ 2.1.0~rc5-1/debian/copyright	2024-06-18 15:40:29.000000000 +0000
@@ -3,7 +3,7 @@ Upstream-Name: voms
 Upstream-Contact:
  Vincenzo Ciaschini <vincenzo.ciaschini@cnaf.infn.it>
  Andrea Ceccanti <andrea.ceccanti@cnaf.infn.it>
-Source: https://github.com/italiangrid/voms/archive/v2.1.0-rc4/voms-2.1.0-rc4.tar.gz
+Source: https://github.com/italiangrid/voms/archive/v2.1.0-rc5/voms-2.1.0-rc5.tar.gz
 
 Files: *
 Copyright:
diff -pruN 2.1.0~rc4-1/debian/rules 2.1.0~rc5-1/debian/rules
--- 2.1.0~rc4-1/debian/rules	2023-09-15 03:42:14.000000000 +0000
+++ 2.1.0~rc5-1/debian/rules	2024-06-18 15:42:12.000000000 +0000
@@ -33,8 +33,8 @@ override_dh_auto_install:
 	rm debian/tmp/usr/share/voms/vomses.template
 
 	# Service unit file
-	mkdir -p debian/tmp/lib/systemd/system
-	install -m 644 systemd/voms@.service debian/tmp/lib/systemd/system
+	mkdir -p debian/tmp/usr/lib/systemd/system
+	install -m 644 systemd/voms@.service debian/tmp/usr/lib/systemd/system
 
 	# /var/lock/subsys is a redhat-ism - use /var/run/voms instead
 	sed -e 's!/lock/subsys!/run/voms!g' -i debian/tmp/etc/init.d/voms
diff -pruN 2.1.0~rc4-1/debian/voms-server.install 2.1.0~rc5-1/debian/voms-server.install
--- 2.1.0~rc4-1/debian/voms-server.install	2023-02-10 06:11:31.000000000 +0000
+++ 2.1.0~rc5-1/debian/voms-server.install	2024-06-18 15:42:12.000000000 +0000
@@ -7,7 +7,7 @@
 /usr/share/voms/voms_replica_master_setup.sh
 /usr/share/voms/voms_replica_slave_setup.sh
 /usr/share/man/man8/voms.8
-/lib/systemd/system/voms@.service
+/usr/lib/systemd/system/voms@.service
 /etc/default/voms
 /etc/init.d/voms
 /etc/voms
diff -pruN 2.1.0~rc4-1/docker-compose.yml 2.1.0~rc5-1/docker-compose.yml
--- 2.1.0~rc4-1/docker-compose.yml	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/docker-compose.yml	2024-06-17 08:16:21.000000000 +0000
@@ -4,7 +4,7 @@ volumes:
 
 services:
   trust:
-    image: indigoiam/egi-trustanchors
+    image: indigoiam/egi-trustanchors:igi-test-ca
 
     volumes:
       - trustanchors:/tmp/certificates
diff -pruN 2.1.0~rc4-1/m4/acinclude.m4 2.1.0~rc5-1/m4/acinclude.m4
--- 2.1.0~rc4-1/m4/acinclude.m4	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/m4/acinclude.m4	2024-06-17 08:16:21.000000000 +0000
@@ -40,7 +40,7 @@ AC_DEFUN([AC_BUILD_PARTS],
       case "$withval" in
         yes) build_clients="yes" ;;
         no)  build_clients="no" ;;
-        *) AC_MSG_ERROR([bad value $withval for --with-client]) ;;
+        *) AC_MSG_ERROR([bad value $withval for --with-clients]) ;;
       esac
     ],
     [ build_clients="$build_all" ])
diff -pruN 2.1.0~rc4-1/src/ac/write.c 2.1.0~rc5-1/src/ac/write.c
--- 2.1.0~rc4-1/src/ac/write.c	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/ac/write.c	2024-06-17 08:16:21.000000000 +0000
@@ -75,13 +75,18 @@ AC_TARGET* build_ac_target(char* t){
         ASN1_IA5STRING_free(target_str);
         return NULL;
     }
+    GENERAL_NAME *name = GENERAL_NAME_new();
+    if (! name) {
+        AC_TARGET_free(target);
+        ASN1_IA5STRING_free(target_str);
+        return NULL;
+    }
 
     ASN1_STRING_set(target_str, t, strlen(t));
 
-    GENERAL_NAME *name = target->name;
-
     name->type = GEN_URI;
     name->d.ia5 = target_str;
+    target->name = name;
 
     return target;
 }
diff -pruN 2.1.0~rc4-1/src/api/ccapi/voms_api.cc 2.1.0~rc5-1/src/api/ccapi/voms_api.cc
--- 2.1.0~rc4-1/src/api/ccapi/voms_api.cc	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/api/ccapi/voms_api.cc	2024-06-17 08:16:21.000000000 +0000
@@ -73,6 +73,8 @@ extern int InitProxyCertInfoExtension(in
 #include <fstream>
 #include <iostream>
 #include <map>
+#include <algorithm>
+#include <sstream>
 
 #include <voms_api.h>
 #include "data.h"
@@ -247,21 +249,18 @@ bool vomsdata::InterpretOutput(const std
 
     if (!a.ac.empty()) {
       output = a.ac;
-      if (a.errs.size() != 0) {
-        std::vector<errorp>::const_iterator end = a.errs.end();
-        for (std::vector<errorp>::const_iterator i = a.errs.begin();
-             i != end; ++i) {
-          serverrors += i->message;
-          if (i->num > ERROR_OFFSET)
-            result = false;
-          if (i->num == WARN_NO_FIRST_SELECT)
-            seterror(VERR_ORDER, "Cannot put requested attributes in the specified order.");
-        }
-      }
     }
     else if (!a.data.empty()) {
       output = a.data;
     }
+    for (std::vector<errorp>::const_iterator i = a.errs.begin(), end = a.errs.end();
+         i != end; ++i) {
+      serverrors += i->message;
+      if (i->num > ERROR_OFFSET)
+        result = false;
+      if (i->num == WARN_NO_FIRST_SELECT)
+        seterror(VERR_ORDER, "Cannot put requested attributes in the specified order.");
+    }
     if (!result && ver_type) {
       seterror(VERR_SERVERCODE, "The server returned an error.");
       return false;
@@ -289,9 +288,15 @@ bool vomsdata::ContactRaw(std::string ho
   /* Try REST connection first */
   bool ret = ContactRESTRaw(hostname, port, command, raw, version, timeout);
 
-  if (ret)
+  if (ret
+      || serverrors.find("User unknown to this VO") != std::string::npos
+      || serverrors.find("suspended") != std::string::npos
+      || serverrors.find("not active") != std::string::npos)
     return ret;
 
+  // reset the errors
+  serverrors.clear();
+
   std::vector<std::string>::const_iterator end = targets.end();
   std::vector<std::string>::const_iterator begin = targets.begin();
   for (std::vector<std::string>::const_iterator i = begin; i != end; ++i) {
@@ -303,8 +308,12 @@ bool vomsdata::ContactRaw(std::string ho
 
   comm = XML_Req_Encode(command, ordering, targs, duration);
 
-  if (!contact(hostname, port, servsubject, comm, buffer, subject, ca, timeout))
+  ret = contact(hostname, port, servsubject, comm, buffer, subject, ca, timeout);
+  // std::cerr << '\n' << comm << '\n' << buffer << '\n';
+
+  if (!ret) {
     return false;
+  }
 
   version = 1;
   return InterpretOutput(buffer, raw);
@@ -324,12 +333,92 @@ static X509 *get_own_cert()
   return NULL;
 }
 
+static void change(std::string &name, const std::string& from, const std::string& to) 
+{
+  std::string::size_type pos = name.find(from);
+
+  while (pos != std::string::npos) {
+    name = name.substr(0, pos) + to + name.substr(pos+from.length());
+    pos = name.find(from, pos+1);
+  }
+}
+
+static std::vector<std::string> split(std::string const& source, char delim)
+{
+  std::vector<std::string> result;
+  std::istringstream is(source);
+  std::string token;
+
+  while (std::getline(is, token, delim)) {
+    if (!token.empty()) {
+      result.push_back(token);
+    }
+  }
+  return result;
+}
+
+static std::string join(std::vector<std::string> const& v, char delim)
+{
+  std::vector<std::string>::const_iterator it = v.begin();
+  std::vector<std::string>::const_iterator const end = v.end();
+
+  std::string result;
+
+  if (it != end) {
+    result += *it;
+    ++it;
+  }
+
+  for (; it != end; ++it)
+  {
+    result += delim;
+    result += *it;
+  }
+
+  return result;
+}
+
+static bool is_role(std::string const& s)
+{
+  return s.find("/Role=") != std::string::npos;
+}
+
+static std::string merge_order_and_fqans(std::string const& fqans, std::string const& ordering)
+{
+  std::vector<std::string> ordering_v = split(ordering, ',');
+  std::vector<std::string> fqans_v = split(fqans, ',');
+  std::vector<std::string> merged_v;
+
+  for (std::vector<std::string>::iterator it = ordering_v.begin(), end = ordering_v.end();
+       it != end; ++it)
+  {
+    std::vector<std::string>::iterator fqans_it = std::find(fqans_v.begin(), fqans_v.end(), *it);
+    if (fqans_it != fqans_v.end())
+    {
+      merged_v.push_back(*it);
+      fqans_v.erase(fqans_it);
+    } else if (!is_role(*it)) {
+      merged_v.push_back(*it);
+    }
+  }
+
+  merged_v.insert(merged_v.end(), fqans_v.begin(), fqans_v.end());
+
+  return join(merged_v, ',');
+}
 
 bool vomsdata::ContactRESTRaw(const std::string& hostname, int port, const std::string& command, std::string& raw, UNUSED(int version), int timeout)
 {
   std::string temp;
 
-  std::string realCommand = "GET /generate-ac?fqans="+ parse_commands(command);
+  std::string fqans = parse_commands(command);
+
+  if (fqans != "all" && !ordering.empty()) {
+    change(ordering, ":", "/Role=");
+    fqans = merge_order_and_fqans(fqans, ordering);
+  }
+
+  std::string realCommand = "GET /generate-ac?fqans=" + fqans;
 
   realCommand += "&lifetime="+ stringify(duration, temp);
 
@@ -359,6 +448,8 @@ bool vomsdata::ContactRESTRaw(const std:
   std::string user, userca, output;
   bool res = contact(hostname, port, "", realCommand, output, user, userca, timeout);
 
+  // std::cerr << '\n' << realCommand << '\n' << output << '\n';
+
   bool ret = false;
 
   if (res) {
@@ -1046,17 +1137,6 @@ bool vomsdata::LoadCredentials(X509 *cer
   return true;
 }
 
-
-static void change(std::string &name, const std::string& from, const std::string& to) 
-{
-  std::string::size_type pos = name.find(from);
-
-  while (pos != std::string::npos) {
-    name = name.substr(0, pos) + to + name.substr(pos+from.length());
-    pos = name.find(from, pos+1);
-  }
-}
-
 static std::string parse_commands(const std::string& commands)
 {
   if (commands[0] == '/')
diff -pruN 2.1.0~rc4-1/src/client/vomsclient.cc 2.1.0~rc5-1/src/client/vomsclient.cc
--- 2.1.0~rc4-1/src/client/vomsclient.cc	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/client/vomsclient.cc	2024-06-17 08:16:21.000000000 +0000
@@ -67,7 +67,6 @@ extern "C" {
 
 extern "C" 
 {
-  //#include "myproxycertinfo.h"
 #include "vomsproxy.h"
 }
 
@@ -1050,7 +1049,7 @@ bool Client::Test()
     Print(WARN) << std::endl << "ERROR: Your certificate expired "
                 << asctime(localtime(&time_after)) << std::endl;
     
-    return 2;
+    return true;
   } 
   
   if (hours && time_diff < length) {
@@ -1058,7 +1057,7 @@ bool Client::Test()
                 << asctime(localtime(&time_after))
                 << "which is within the requested lifetime of the proxy"
                 << std::endl;
-    return 1;
+    return false;
   }
   
   if (!quiet) {
@@ -1069,7 +1068,7 @@ bool Client::Test()
                 << asctime(localtime(&time_after_proxy)) << std::flush;
   }
 
-  return 0;
+  return false;
 }
 
 bool Client::AddToList(AC *ac) 
diff -pruN 2.1.0~rc4-1/src/common/data.cc 2.1.0~rc5-1/src/common/data.cc
--- 2.1.0~rc4-1/src/common/data.cc	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/common/data.cc	2024-06-17 08:16:21.000000000 +0000
@@ -44,6 +44,7 @@ extern "C" {
 
 #include <string>
 #include <vector>
+#include <sstream>
 
 /*
  * Function:
@@ -144,71 +145,24 @@ stringify(int i, std::string &s)
 
 std::string OpenSSLError(bool debug) 
 {
-  unsigned long l;
-  char buf[256];
-#if SSLEAY_VERSION_NUMBER  >= 0x00904100L
-  const char *file;
-#else
-  char *file;
-#endif
-  char *dat;
-  int line;
+  std::ostringstream os;
 
-  std::string outstring;
-  char *msgstring = NULL;
-  char *errstring = NULL;
-
-  /* WIN32 does not have the ERR_get_error_line_data */ 
-  /* exported, so simulate it till it is fixed */
-  /* in SSLeay-0.9.0 */
-  
-  while ( ERR_peek_error() != 0 ) {
-    
-    int i;
-    ERR_STATE *es;
-      
-    es = ERR_get_state();
-    i = (es->bottom+1)%ERR_NUM_ERRORS;
-
-    if (es->err_data[i] == NULL)
-      dat = strdup("");
-    else
-      dat = strdup(es->err_data[i]);
-
-
-    if (dat) {
-      int code = 0;
-
-      l = ERR_get_error_line(&file, &line);
-      code = ERR_GET_REASON(l);
-
-      switch (code) {
-      case SSL_R_SSLV3_ALERT_CERTIFICATE_EXPIRED:
-        outstring += "Either proxy or user certificate are expired.";
-        break;
-
-      default:
-        if (debug) {
-          std::string temp;
-          
-          outstring += std::string(ERR_error_string(l,buf)) + ":" +
-            file + ":" + stringify(line, temp) + dat + "\n";
-        }
-
-        msgstring = (char*)ERR_reason_error_string(l);
-        errstring = (char*)ERR_func_error_string(l);
-
-        if (msgstring)
-          outstring += std::string(msgstring) + std::string(dat ? dat : "") +
-            "\nFunction: " + std::string(errstring ? errstring : "") + "\n";
-        break;
-      }
-    }
-    
-    free(dat);
+  char const *file;
+  int line;
+  char const *data;
+  int flags;
+  unsigned long code = ERR_get_error_line_data(&file, &line, &data, &flags);
+  while (code)
+  {
+    std::size_t const buf_size = 256;
+    char buf[buf_size];
+    ERR_error_string_n(code, buf, buf_size);
+    os << file << ':' << line << ':'
+       << buf << (data && (flags & ERR_TXT_STRING) ? data : "") << '\n';
+    code = ERR_get_error_line_data(&file, &line, &data, &flags);
   }
 
-  return outstring;
+  return os.str();
 }
 
 static char *readfile(const char *file, int *size)
diff -pruN 2.1.0~rc4-1/src/common/xmlcc.cc 2.1.0~rc5-1/src/common/xmlcc.cc
--- 2.1.0~rc4-1/src/common/xmlcc.cc	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/common/xmlcc.cc	2024-06-17 08:16:21.000000000 +0000
@@ -491,7 +491,7 @@ static void endans(void *userdata, const
     a->num = atoi(a->value.c_str());
   }
   else if ((!strcmp(name, "message")) && 
-           (a->depth == 3)) {
+           (a->depth == 3 || a->depth == 2)) {
     a->message = a->value;
   }
   else if (!strcmp(name, "warning")) {
@@ -501,10 +501,10 @@ static void endans(void *userdata, const
     a->a->errs.push_back(e);
   }
   else if ((!strcmp(name, "code")) && 
-           (a->depth == 3)) {
+           (a->depth == 2)) {
     const char *msg = a->value.c_str();
 
-    if (!strcmp(msg, "NoSuchUser"))
+    if (!strcmp(msg, "NoSuchUser") || atoi(msg) == ERR_NOT_MEMBER)
       a->num = ERR_NOT_MEMBER;
     else if (!strcmp(msg, "SuspendedUser"))
       a->num = ERR_SUSPENDED;
diff -pruN 2.1.0~rc4-1/src/include/Makefile.am 2.1.0~rc5-1/src/include/Makefile.am
--- 2.1.0~rc4-1/src/include/Makefile.am	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/include/Makefile.am	2024-06-17 08:16:21.000000000 +0000
@@ -12,6 +12,6 @@ options.h pass.h Server.h fqan.h doio.h
 vomsxml.h errors.h log.h sslutils.h normalize.h \
 listfunc.h credentials.h newformat.h proxycertinfo.h proxypolicy.h \
 acstack.h validate.h ccac.h init.h ccwrite.h getopts.h replace.h dbwrap.h \
-stamp-h.in stamp-h1.in
+stamp-h.in stamp-h1.in ssl_compat.h
 
 MAINTAINERCLEANFILES = Makefile.in
diff -pruN 2.1.0~rc4-1/src/include/myproxycertinfo.h 2.1.0~rc5-1/src/include/myproxycertinfo.h
--- 2.1.0~rc4-1/src/include/myproxycertinfo.h	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/include/myproxycertinfo.h	1970-01-01 00:00:00.000000000 +0000
@@ -1,131 +0,0 @@
-/*********************************************************************
- *
- * Authors: Vincenzo Ciaschini - Vincenzo.Ciaschini@cnaf.infn.it 
- *          Valerio Venturi    - valerio.venturi@cnaf.infn.it
- *
- * Copyright (c) Members of the EGEE Collaboration. 2004-2010.
- * See http://www.eu-egee.org/partners/ for details on the copyright holders.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *    http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- *
- * Parts of this code may be based upon or even include verbatim pieces,
- * originally written by other people, in which case the original header
- * follows.
- *
- *********************************************************************/
-#ifndef VOMS_PROXYCERTINFO_H
-#define VOMS_PROXYCERTINFO_H
-
-#include <openssl/x509.h>
-#include <openssl/x509v3.h>
-#include <string.h>
-
-/* predefined policy language */
-#define IMPERSONATION_PROXY_OID         "1.3.6.1.5.5.7.21.1"
-#define IMPERSONATION_PROXY_SN          "IMPERSONATION_PROXY"
-#define IMPERSONATION_PROXY_LN          "GSI impersonation proxy"
-
-#define INDEPENDENT_PROXY_OID           "1.3.6.1.5.5.7.21.2"
-#define INDEPENDENT_PROXY_SN            "INDEPENDENT_PROXY"
-#define INDEPENDENT_PROXY_LN            "GSI independent proxy"
-
-/* generic policy language */
-#define GLOBUS_GSI_PROXY_GENERIC_POLICY_OID "1.3.6.1.4.1.3536.1.1.1.8"
-
-#define LIMITED_PROXY_OID               "1.3.6.1.4.1.3536.1.1.1.9"
-#define LIMITED_PROXY_SN                "LIMITED_PROXY"
-#define LIMITED_PROXY_LN                "GSI limited proxy"
-
-#define PROXYCERTINFO_V3                "1.3.6.1.4.1.3536.1.222"
-#define PROXYCERTINFO_V4                "1.3.6.1.5.5.7.1.14"
-
-/* error handling */
-#define ASN1_F_PROXYPOLICY_NEW          450
-#define ASN1_F_D2I_PROXYPOLICY          451
-#define ASN1_F_PROXYCERTINFO_NEW        430
-#define ASN1_F_D2I_PROXYCERTINFO        431
-
-/* data structure */
-
-typedef struct myPROXYPOLICY_st {
-
-    ASN1_OBJECT *                       policy_language;
-    ASN1_OCTET_STRING *                 policy;
-
-} myPROXYPOLICY;
-
-typedef struct myPROXYCERTINFO_st {
- 
-  ASN1_INTEGER * path_length;
-  myPROXYPOLICY * proxypolicy;
-  int version;
-} myPROXYCERTINFO;
-
-
-/* myPROXYPOLICY function */
-
-/* allocating and free memory */
-extern myPROXYPOLICY * myPROXYPOLICY_new();
-extern void myPROXYPOLICY_free(myPROXYPOLICY * proxypolicy);
-
-/* duplicate */
-extern myPROXYPOLICY * myPROXYPOLICY_dup(myPROXYPOLICY * policy);
-
-/* set policy language */
-extern int myPROXYPOLICY_set_policy_language(myPROXYPOLICY * policy, ASN1_OBJECT * policy_language);
-
-/* get policy language */
-extern ASN1_OBJECT * myPROXYPOLICY_get_policy_language(myPROXYPOLICY * policy);
-
-/* set policy contents */
-extern int myPROXYPOLICY_set_policy(myPROXYPOLICY * proxypolicy, unsigned char * policy, int length);
-
-/* get policy contents */
-extern unsigned char * myPROXYPOLICY_get_policy(myPROXYPOLICY * policy, int * length);
-
-/* internal to der conversion */
-extern int i2d_myPROXYPOLICY(myPROXYPOLICY * policy, unsigned char ** pp);
-
-/* der to internal conversion */
-extern myPROXYPOLICY * d2i_myPROXYPOLICY(myPROXYPOLICY ** policy, unsigned char ** pp, long length);
-
-/*myPROXYCERTINFO function */
-
-/* allocating and free memory */
-extern myPROXYCERTINFO * myPROXYCERTINFO_new();
-extern void myPROXYCERTINFO_free(myPROXYCERTINFO * proxycertinfo);
-
-/* set path_length */
-extern int myPROXYCERTINFO_set_path_length(myPROXYCERTINFO * proxycertinfo, long path_length);
-
-/* get ptah length */
-extern long myPROXYCERTINFO_get_path_length(myPROXYCERTINFO * proxycertinfo);
-
-/* set proxypolicy */
-extern int myPROXYCERTINFO_set_proxypolicy(myPROXYCERTINFO * proxycertinfo, myPROXYPOLICY * proxypolicy);
-
-/* get proxypolicy */
-extern myPROXYPOLICY * myPROXYCERTINFO_get_proxypolicy(myPROXYCERTINFO * proxycertinfo);
-
-/* internal to der conversion */
-extern int i2d_myPROXYCERTINFO(myPROXYCERTINFO * proxycertinfo, unsigned char ** pp);
-
-/* der to internal conversion */
-extern myPROXYCERTINFO * d2i_myPROXYCERTINFO(myPROXYCERTINFO ** cert_info, unsigned char ** a, long length);
-
-extern int myPROXYCERTINFO_set_version(myPROXYCERTINFO *cert_info, int version);
-
-extern int proxynative(void);
-extern void InitProxyCertInfoExtension(int full);
-
-#endif
diff -pruN 2.1.0~rc4-1/src/socklib/Server.cpp 2.1.0~rc5-1/src/socklib/Server.cpp
--- 2.1.0~rc4-1/src/socklib/Server.cpp	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/socklib/Server.cpp	2024-06-17 08:16:21.000000000 +0000
@@ -719,7 +719,8 @@ void GSISocketServer::SetErrorOpenSSL(co
 
   while( ERR_peek_error() ){
 
-    char error_msg_buf[512];
+    std::size_t const error_msg_buf_size = 512;
+    char error_msg_buf[error_msg_buf_size];
 
     const char *filename;
     int lineno;
@@ -729,7 +730,6 @@ void GSISocketServer::SetErrorOpenSSL(co
     long error_code = ERR_get_error_line_data(&filename, &lineno, &data, &flags);
 
     const char *lib = ERR_lib_error_string(error_code);
-    const char *func = ERR_func_error_string(error_code);
     const char *error_reason = ERR_reason_error_string(error_code);
 
     if (lib == NULL) {
@@ -741,11 +741,11 @@ void GSISocketServer::SetErrorOpenSSL(co
       }
     }
 
-    sprintf(error_msg_buf,
-        "%s %s [err:%lu,lib:%s,func:%s(file: %s+%d)]",
+    snprintf(error_msg_buf, error_msg_buf_size,
+        "%s %s [err:%lu,lib:%s,file:%s+%d]",
         (error_reason) ? error_reason : "",
-        (data) ? data : "",
-        error_code,lib,func,filename,lineno);
+        (data && (flags & ERR_TXT_STRING)) ? data : "",
+        error_code,lib,filename,lineno);
 
     openssl_errors.push_back(error_msg_buf);
   }
diff -pruN 2.1.0~rc4-1/src/sslutils/Makefile.am 2.1.0~rc5-1/src/sslutils/Makefile.am
--- 2.1.0~rc4-1/src/sslutils/Makefile.am	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/sslutils/Makefile.am	2024-06-17 08:16:21.000000000 +0000
@@ -15,7 +15,7 @@ SOURCES= scutils.c scutils.h sslutils.c
 
 EXTRA_DIST = 	namespaces.l namespaces.y namespaces.h \
 		signing_policy.y signing_policy.l signing_policy.h \
-		parsertypes.h
+		parsertypes.h lexparse.h
 
 evaluate.$(OBJEXT): signing_policy.h namespaces.h parsertypes.h evaluate.c
 
diff -pruN 2.1.0~rc4-1/src/sslutils/myproxycertinfo.c 2.1.0~rc5-1/src/sslutils/myproxycertinfo.c
--- 2.1.0~rc4-1/src/sslutils/myproxycertinfo.c	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/sslutils/myproxycertinfo.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,510 +0,0 @@
-/*********************************************************************
- *
- * Authors: Valerio Venturi - Valerio.Venturi@cnaf.infn.it
- *          Vincenzo Ciaschini - Vincenzo.Ciaschini@cnaf.infn.it
- *
- * Copyright (c) Members of the EGEE Collaboration. 2004-2010.
- * See http://www.eu-egee.org/partners/ for details on the copyright holders.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *    http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- *
- * Parts of this code may be based upon or even include verbatim pieces,
- * originally written by other people, in which case the original header
- * follows.
- *
- *********************************************************************/
-#include "config.h"
-
-#include <stdio.h>
-
-#include <openssl/err.h>
-#include <openssl/asn1.h>
-#include <openssl/objects.h>
-
-#include "myproxycertinfo.h"
-#include "doio.h"
-
-/* myPROXYPOLICY function */
-
-myPROXYPOLICY * myPROXYPOLICY_new() 
-{
-  myPROXYPOLICY* ret = (myPROXYPOLICY*)OPENSSL_malloc(sizeof(myPROXYPOLICY));
-
-  if (ret)
-  {
-    ret->policy_language = OBJ_nid2obj(OBJ_sn2nid(IMPERSONATION_PROXY_SN));
-    ret->policy = NULL;
-  }
-
-  return ret;
-}
-
-void myPROXYPOLICY_free(myPROXYPOLICY * policy) 
-{
-  if(policy == NULL) return;
-
-  ASN1_OBJECT_free(policy->policy_language);
-  ASN1_OCTET_STRING_free(policy->policy);
-  OPENSSL_free(policy);
-}
-
-/* duplicate */
-myPROXYPOLICY * myPROXYPOLICY_dup(myPROXYPOLICY * policy) 
-{
-#ifdef TYPEDEF_I2D_OF
-  return ((myPROXYPOLICY *) ASN1_dup((i2d_of_void *)i2d_myPROXYPOLICY,
-				   (d2i_of_void *)d2i_myPROXYPOLICY,
-				   (char *)policy));
-#else
-  return ((myPROXYPOLICY *) ASN1_dup((int (*)())i2d_myPROXYPOLICY,
-				   (char *(*)())d2i_myPROXYPOLICY,
-				   (char *)policy));
-#endif
-}
-
-/* set policy language */
-int myPROXYPOLICY_set_policy_language(myPROXYPOLICY * policy, ASN1_OBJECT * policy_language) 
-{
-  if(policy_language != NULL) {
-    ASN1_OBJECT_free(policy->policy_language);
-    policy->policy_language = OBJ_dup(policy_language);
-    return 1;
-  }
-
-  return 0;
-}
-
-/* get policy language */
-ASN1_OBJECT * myPROXYPOLICY_get_policy_language(myPROXYPOLICY * policy)
-{
-    return policy->policy_language;
-}
-
-/* set policy */
-int myPROXYPOLICY_set_policy(myPROXYPOLICY * proxypolicy, unsigned char * policy, int length) 
-{
-  if(policy != NULL) {
-    /* if member policy of proxypolicy non set */
-    if(!proxypolicy->policy)
-      proxypolicy->policy = ASN1_OCTET_STRING_new();
-      
-    /* set member policy of proxypolicy */
-    ASN1_OCTET_STRING_set(proxypolicy->policy, policy, length);
-  }
-  else 
-    ASN1_OCTET_STRING_free(proxypolicy->policy);
-
-  return 1;
-}
-
-/* get policy */
-unsigned char * myPROXYPOLICY_get_policy(myPROXYPOLICY * proxypolicy, int * length) 
-{
-  /* assure field policy is set */
-
-  if(proxypolicy->policy) {
-    *length = proxypolicy->policy->length;
-
-    /* assure ASN1_OCTET_STRING is full */
-    if (*length>0 && proxypolicy->policy->data) {
-      unsigned char * copy = malloc(*length);
-      memcpy(copy, proxypolicy->policy->data, *length);
-      return copy;
-    }
-  }
-  return NULL;
-}
-
-/* internal to der conversion */
-int i2d_myPROXYPOLICY(myPROXYPOLICY * policy, unsigned char ** pp) 
-{
-  M_ASN1_I2D_vars(policy);
-
-  M_ASN1_I2D_len(policy->policy_language, i2d_ASN1_OBJECT);
-
-  if(policy->policy) { 
-    M_ASN1_I2D_len(policy->policy, i2d_ASN1_OCTET_STRING);
-  }
-    
-  M_ASN1_I2D_seq_total();
-  M_ASN1_I2D_put(policy->policy_language, i2d_ASN1_OBJECT);
-
-  if(policy->policy) { 
-    M_ASN1_I2D_put(policy->policy, i2d_ASN1_OCTET_STRING);
-  }
-
-  M_ASN1_I2D_finish();
-}
-
-myPROXYPOLICY * d2i_myPROXYPOLICY(myPROXYPOLICY ** a, unsigned char ** pp, long length)
-{
-    M_ASN1_D2I_vars(a, myPROXYPOLICY *, myPROXYPOLICY_new);
-    
-    M_ASN1_D2I_Init();
-    M_ASN1_D2I_start_sequence();
-    M_ASN1_D2I_get(ret->policy_language, d2i_ASN1_OBJECT);
-
-    /* need to try getting the policy using
-     *     a) a call expecting no tags
-     *     b) a call expecting tags
-     * one of which should succeed
-     */
-    
-    M_ASN1_D2I_get_opt(ret->policy,
-                       d2i_ASN1_OCTET_STRING,
-                       V_ASN1_OCTET_STRING);
-    M_ASN1_D2I_get_IMP_opt(ret->policy,
-                           d2i_ASN1_OCTET_STRING,
-                           0,
-                           V_ASN1_OCTET_STRING);
-    M_ASN1_D2I_Finish(a, 
-                      myPROXYPOLICY_free, 
-                      ASN1_F_D2I_PROXYPOLICY);
-}
-
-
-
-/* myPROXYCERTINFO function */
-
-myPROXYCERTINFO * myPROXYCERTINFO_new() 
-{
-  myPROXYCERTINFO *                   ret = NULL;
-  ASN1_CTX                            c;
-
-  M_ASN1_New_Malloc(ret, myPROXYCERTINFO);
-  memset(ret, 0, sizeof(myPROXYCERTINFO));
-  ret->path_length      = NULL;
-  ret->proxypolicy           = myPROXYPOLICY_new();
-  return (ret);
-  M_ASN1_New_Error(ASN1_F_PROXYCERTINFO_NEW);
-}
-
-void myPROXYCERTINFO_free(myPROXYCERTINFO * proxycertinfo) 
-{ 
-  /* assure proxycertinfo not empty */ 
-  if(proxycertinfo == NULL) return;
-  
-  ASN1_INTEGER_free(proxycertinfo->path_length);
-  myPROXYPOLICY_free(proxycertinfo->proxypolicy);
-  OPENSSL_free(proxycertinfo);
-}
-
-/* set path_length */
-int myPROXYCERTINFO_set_path_length(myPROXYCERTINFO * proxycertinfo, long path_length) 
-{  
-  /* assure proxycertinfo is not empty */
-  if(proxycertinfo != NULL) {
-
-    if(path_length != -1) {
-      /* if member path_length is empty allocate memory then set */
-      if(proxycertinfo->path_length == NULL)
-	proxycertinfo->path_length = ASN1_INTEGER_new();
-      return ASN1_INTEGER_set(proxycertinfo->path_length, path_length);
-    }
-    else {
-      ASN1_INTEGER_free(proxycertinfo->path_length);
-      proxycertinfo->path_length = NULL;
-    }
-
-    return 1;
-  }
-
-  return 0;
-}
-
-int myPROXYCERTINFO_set_version(myPROXYCERTINFO * proxycertinfo, int version)
-{
-  if (proxycertinfo != NULL) {
-    proxycertinfo->version = version;
-    return 1;
-  }
-
-  return 0;
-}
-
-int myPROXYCERTINFO_get_version(myPROXYCERTINFO * proxycertinfo)
-{
-  if (proxycertinfo)
-    return proxycertinfo->version;
-  return -1;
-}
-
-
-/* get path length */
-long myPROXYCERTINFO_get_path_length(myPROXYCERTINFO * proxycertinfo) 
-{
-  if(proxycertinfo && proxycertinfo->path_length)
-    return ASN1_INTEGER_get(proxycertinfo->path_length);
-  else 
-    return -1;
-}
-
-/* set policy */
-int myPROXYCERTINFO_set_proxypolicy(myPROXYCERTINFO * proxycertinfo, myPROXYPOLICY * proxypolicy) 
-{
-  myPROXYPOLICY_free(proxycertinfo->proxypolicy);
-
-  if(proxypolicy != NULL)
-    proxycertinfo->proxypolicy = myPROXYPOLICY_dup(proxypolicy);
-  else
-    proxycertinfo->proxypolicy = NULL;
-
-  return 1;
-}
-
-/* get policy */
-myPROXYPOLICY * myPROXYCERTINFO_get_proxypolicy(myPROXYCERTINFO * proxycertinfo) 
-{
-  if(proxycertinfo)
-    return proxycertinfo->proxypolicy;
-
-  return NULL;
-}
-
-/* internal to der conversion */
-static int i2d_myPROXYCERTINFO_v3(myPROXYCERTINFO * proxycertinfo, unsigned char ** pp) 
-{
-    int                                 v1;
-
-    M_ASN1_I2D_vars(proxycertinfo);
-    
-    v1 = 0;
-
-    M_ASN1_I2D_len(proxycertinfo->proxypolicy, i2d_myPROXYPOLICY);
-
-    M_ASN1_I2D_len_EXP_opt(proxycertinfo->path_length,i2d_ASN1_INTEGER, 1, v1);
-    M_ASN1_I2D_seq_total();
-    M_ASN1_I2D_put(proxycertinfo->proxypolicy, i2d_myPROXYPOLICY);
-    M_ASN1_I2D_put_EXP_opt(proxycertinfo->path_length, i2d_ASN1_INTEGER, 1, v1);
-    M_ASN1_I2D_finish();
-}
-
-static int i2d_myPROXYCERTINFO_v4(myPROXYCERTINFO * proxycertinfo, unsigned char ** pp) 
-{
-    M_ASN1_I2D_vars(proxycertinfo);
-
-    if(proxycertinfo->path_length)
-    { 
-        M_ASN1_I2D_len(proxycertinfo->path_length, i2d_ASN1_INTEGER);
-    }
-    
-    M_ASN1_I2D_len(proxycertinfo->proxypolicy, i2d_myPROXYPOLICY);
-
-    M_ASN1_I2D_seq_total();
-    if(proxycertinfo->path_length)
-    { 
-        M_ASN1_I2D_put(proxycertinfo->path_length, i2d_ASN1_INTEGER);
-    }
-    M_ASN1_I2D_put(proxycertinfo->proxypolicy, i2d_myPROXYPOLICY);
-    M_ASN1_I2D_finish();
-}
-
-int i2d_myPROXYCERTINFO(myPROXYCERTINFO * proxycertinfo, unsigned char ** pp) 
-{
-  switch(proxycertinfo->version) {
-  case 3:
-    return i2d_myPROXYCERTINFO_v3(proxycertinfo, pp);
-    break;
-
-  case 4:
-    return i2d_myPROXYCERTINFO_v4(proxycertinfo, pp);
-    break;
-
-  default:
-    return -1;
-    break;
-  }
-}
-
-static myPROXYCERTINFO * d2i_myPROXYCERTINFO_v3(myPROXYCERTINFO ** cert_info, unsigned char ** pp, long length)
-{
-    M_ASN1_D2I_vars(cert_info, myPROXYCERTINFO *, myPROXYCERTINFO_new);
-
-    M_ASN1_D2I_Init();
-    M_ASN1_D2I_start_sequence();
-
-    M_ASN1_D2I_get((ret->proxypolicy), d2i_myPROXYPOLICY);
-
-    M_ASN1_D2I_get_EXP_opt(ret->path_length, d2i_ASN1_INTEGER, 1);
-
-    ret->version = 3;
-    M_ASN1_D2I_Finish(cert_info, myPROXYCERTINFO_free, ASN1_F_D2I_PROXYCERTINFO);
-}
-
-static myPROXYCERTINFO * d2i_myPROXYCERTINFO_v4(myPROXYCERTINFO ** cert_info, unsigned char ** pp, long length)
-{
-    M_ASN1_D2I_vars(cert_info, myPROXYCERTINFO *, myPROXYCERTINFO_new);
-
-    M_ASN1_D2I_Init();
-    M_ASN1_D2I_start_sequence();
-
-    M_ASN1_D2I_get_EXP_opt(ret->path_length, d2i_ASN1_INTEGER, 1);
-    
-    M_ASN1_D2I_get_opt(ret->path_length, d2i_ASN1_INTEGER, V_ASN1_INTEGER);
-
-    M_ASN1_D2I_get((ret->proxypolicy),d2i_myPROXYPOLICY);
-
-    ret->version = 4;
-    M_ASN1_D2I_Finish(cert_info, myPROXYCERTINFO_free, ASN1_F_D2I_PROXYCERTINFO);
-}
-
-myPROXYCERTINFO * d2i_myPROXYCERTINFO(myPROXYCERTINFO ** cert_info, unsigned char ** pp, long length)
-{
-  myPROXYCERTINFO *info = d2i_myPROXYCERTINFO_v3(cert_info, pp, length);
-  if (!info)
-    info = d2i_myPROXYCERTINFO_v4(cert_info, pp, length);
-  return info;
-}
-
-
-static int nativeopenssl = 0;
-
-static char *norep()
-{
-  static char *buffer="";
-  return buffer;
-}
-
-static void *myproxycertinfo_s2i(UNUSED(struct v3_ext_method *method), UNUSED(struct v3_ext_ctx *ctx), UNUSED(char *data))
-{
-  return (myPROXYCERTINFO*)data;
-}
-
-static char *myproxycertinfo_i2s(UNUSED(struct v3_ext_method *method), void *ext)
-{
-  myPROXYCERTINFO *pci = NULL;
-  char *encoding = NULL;
-  char *output = NULL;
-  myPROXYPOLICY *pp;
-  int dooid = 0;
-  char oid[256];
-
-  pci = (myPROXYCERTINFO *)ext;
- 
-  if (!pci)
-    return norep();
-
-  if (pci->path_length) {
-    int j = ASN1_INTEGER_get(pci->path_length);
-
-    char *buffer = snprintf_wrap("%X", j);
-    output = snprintf_wrap("Path Length Constraint: %s%s\n\n", strlen(buffer)%2 ? "0" : "", buffer);
-    free(buffer);
-  }
-  else
-    output = strdup("Path Length Constraint: unlimited\n");
-
-  pp = pci->proxypolicy;
-
-  if (pp && i2t_ASN1_OBJECT(oid, 256, pp->policy_language)) {
-    dooid  = 1;
-  }
-
-  encoding = snprintf_wrap("%sPolicy Language: %s%s%s%s\n", 
-			   output, 
-			   ( dooid ? oid : ""), 
-			   ( (pp && pp->policy) ? "\nPolicy Text: " : ""), 
-         ( (pp && pp->policy) ? (char*)ASN1_STRING_data(pp->policy) : ""),
-			   ( (pp && pp->policy) ? "\n" : ""));
-
-  free(output);
-  return encoding;
-}
-
-void InitProxyCertInfoExtension(int full)
-{
-#define PROXYCERTINFO_V3      "1.3.6.1.4.1.3536.1.222"
-#define PROXYCERTINFO_V4      "1.3.6.1.5.5.7.1.14"
-#define OBJC(c,n) OBJ_create(c,n,n)
-
-  X509V3_EXT_METHOD *pcert;
-  static int set = 0;
-  ASN1_OBJECT *objv3;
-  ASN1_OBJECT *objv4;
-
-  if (set)
-    return;
-
-  set = 1;
-
-
-  objv3 = OBJ_txt2obj(PROXYCERTINFO_V3,1);
-  objv4 = OBJ_txt2obj(PROXYCERTINFO_V4,1);
-
-  /* Proxy Certificate Extension's related objects */
-  if (OBJ_obj2nid(objv3) == 0) {
-    ERR_clear_error();
-    OBJC(PROXYCERTINFO_V3, "Proxy Certificate Information");
-    if (full) {
-      pcert = (X509V3_EXT_METHOD *)OPENSSL_malloc(sizeof(X509V3_EXT_METHOD));
-
-      if (pcert) {
-        memset(pcert, 0, sizeof(*pcert));
-        pcert->ext_nid = OBJ_txt2nid(PROXYCERTINFO_V3);
-        pcert->ext_flags = 0;
-        pcert->ext_new  = (X509V3_EXT_NEW) myPROXYCERTINFO_new;
-        pcert->ext_free = (X509V3_EXT_FREE)myPROXYCERTINFO_free;
-        pcert->d2i      = (X509V3_EXT_D2I) d2i_myPROXYCERTINFO;
-        pcert->i2d      = (X509V3_EXT_I2D) i2d_myPROXYCERTINFO;
-        pcert->i2s      = (X509V3_EXT_I2S) myproxycertinfo_i2s;
-        pcert->s2i      = (X509V3_EXT_S2I) myproxycertinfo_s2i;
-        pcert->v2i      = (X509V3_EXT_V2I) NULL;
-        pcert->r2i      = (X509V3_EXT_R2I) NULL;
-        pcert->i2v      = (X509V3_EXT_I2V) NULL;
-        pcert->i2r      = (X509V3_EXT_I2R) NULL;
-
-        X509V3_EXT_add(pcert);
-      }
-    }
-  }
-
-  if (OBJ_obj2nid(objv4) == 0) {
-    ERR_clear_error();
-    OBJC(PROXYCERTINFO_V4, "Proxy Certificate Information");
-    if (full) {
-      pcert = (X509V3_EXT_METHOD *)OPENSSL_malloc(sizeof(X509V3_EXT_METHOD));
-    
-      if (pcert) {
-        memset(pcert, 0, sizeof(*pcert));
-        pcert->ext_nid = OBJ_txt2nid(PROXYCERTINFO_V4);
-        pcert->ext_flags = 0;
-        pcert->ext_new  = (X509V3_EXT_NEW) myPROXYCERTINFO_new;
-        pcert->ext_free = (X509V3_EXT_FREE)myPROXYCERTINFO_free;
-        pcert->d2i      = (X509V3_EXT_D2I) d2i_myPROXYCERTINFO;
-        pcert->i2d      = (X509V3_EXT_I2D) i2d_myPROXYCERTINFO;
-        pcert->i2s      = (X509V3_EXT_I2S) myproxycertinfo_i2s;
-        pcert->s2i      = (X509V3_EXT_S2I) myproxycertinfo_s2i;
-        pcert->v2i      = (X509V3_EXT_V2I) NULL;
-        pcert->r2i      = (X509V3_EXT_R2I) NULL;
-        pcert->i2v      = (X509V3_EXT_I2V) NULL;
-        pcert->i2r      = (X509V3_EXT_I2R) NULL;
-    
-        X509V3_EXT_add(pcert);
-      }
-    }
-  }
-
-#ifdef X509_V_FLAG_ALLOW_PROXY_CERTS
-  nativeopenssl = 1;
-#endif
-
-  ASN1_OBJECT_free(objv3);
-  ASN1_OBJECT_free(objv4);
-
-  return;
-}
-
-int proxynative(void)
-{
-  return nativeopenssl;
-}
diff -pruN 2.1.0~rc4-1/src/sslutils/sslutils.c 2.1.0~rc5-1/src/sslutils/sslutils.c
--- 2.1.0~rc4-1/src/sslutils/sslutils.c	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/sslutils/sslutils.c	2024-06-17 08:16:21.000000000 +0000
@@ -519,7 +519,7 @@ ERR_load_prxyerr_strings(
 
         randfile = RAND_file_name(buffer,200);
 
-        if (randfile)
+        if (randfile && access(randfile, R_OK) == 0)
         {
             RAND_load_file(randfile,1024L*1024L);
         }
diff -pruN 2.1.0~rc4-1/src/utils/Makefile.am 2.1.0~rc5-1/src/utils/Makefile.am
--- 2.1.0~rc4-1/src/utils/Makefile.am	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/src/utils/Makefile.am	2024-06-17 08:16:21.000000000 +0000
@@ -41,7 +41,7 @@ voms_proxy_fake_SOURCES = \
 	vomsparser.c \
 	lex.yy.c 
 
-EXTRA_DIST = vomsfake.y vomsparser.l vomsparser.h fakeparsertypes.h
+EXTRA_DIST = vomsfake.y vomsparser.l vomsparser.h fakeparsertypes.h lexparse.h
 
 vomsfake.$(OBJEXT): vomsparser.h
 
diff -pruN 2.1.0~rc4-1/systemd/voms@.service 2.1.0~rc5-1/systemd/voms@.service
--- 2.1.0~rc4-1/systemd/voms@.service	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/systemd/voms@.service	2024-06-17 08:16:21.000000000 +0000
@@ -3,7 +3,7 @@ Description=VOMS service for VO %i
 
 [Service]
 WorkingDirectory=/
-EnvironmentFile=/etc/sysconfig/voms
+EnvironmentFile=-/etc/sysconfig/voms
 User=voms
 Type=forking
 ExecStart=/usr/sbin/voms --conf /etc/voms/%i/voms.conf
diff -pruN 2.1.0~rc4-1/testsuite/voms/voms/server.c 2.1.0~rc5-1/testsuite/voms/voms/server.c
--- 2.1.0~rc4-1/testsuite/voms/voms/server.c	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/testsuite/voms/voms/server.c	2024-06-17 08:16:21.000000000 +0000
@@ -164,11 +164,8 @@ int main(int argc, char *argv[])
         //      if (debug)
         fprintf(stdout, "%s:%s,%d,%s\n", ERR_error_string(l, buf),
                 file, line, dat);
-        //      error += std::string(ERR_reason_error_string(l)) + ":" + std::string(ERR_func_error_string(l)) + "\n";
       }
     }
-/*     fprintf(stdout, "%s\n", */
-/*             ERR_reason_error_string( ERR_get_error() )); */
     fprintf(stdout, "ERROR\n");
     exit(1);
   }
diff -pruN 2.1.0~rc4-1/testsuite/voms/voms/server2.c 2.1.0~rc5-1/testsuite/voms/voms/server2.c
--- 2.1.0~rc4-1/testsuite/voms/voms/server2.c	2024-05-03 11:04:16.000000000 +0000
+++ 2.1.0~rc5-1/testsuite/voms/voms/server2.c	2024-06-17 08:16:21.000000000 +0000
@@ -161,11 +161,8 @@ int main(int argc, char *argv[])
         //      if (debug)
         fprintf(stdout, "%s:%s,%d,%s\n", ERR_error_string(l, buf),
                 file, line, dat);
-        //      error += std::string(ERR_reason_error_string(l)) + ":" + std::string(ERR_func_error_string(l)) + "\n";
       }
     }
-/*     fprintf(stdout, "%s\n", */
-/*             ERR_reason_error_string( ERR_get_error() )); */
     fprintf(stdout, "ERROR\n");
     exit(1);
   }
